﻿
namespace Library.Services {
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.Linq;
    using System.Web.Ria;
    using System.Web.Ria.Data;
    using System.Web.DomainServices;
    using System.Data.Linq;
    using System.Web.DomainServices.LinqToSql;
    using Library.DataModel;
    using System.Data.Linq.SqlClient;


    // Implements application logic using the LibraryDBDataContext context.
    // TODO: Add your application logic to these methods or in additional methods.
    [EnableClientAccess()]
    public class LibraryManagementService : LinqToSqlDomainService<LibraryDBDataContext> {

        public IQueryable<Book> GetBooks() {
            return from b in Context.Books
                   where b.Missing == false
                   orderby b.PublishDate descending
                   select b;
        }

        public IQueryable<Book> SearchBooks(string searchText) {
            if (String.IsNullOrEmpty(searchText)) {
                return GetBooks();
            }

            string searchPattern = "%" + searchText + "%";

            return from b in Context.Books
                   where b.Missing == false &&
                         (SqlMethods.Like(b.Title, searchPattern) ||
                          SqlMethods.Like(b.Author, searchPattern) ||
                          SqlMethods.Like(b.Description, searchPattern))
                   orderby b.PublishDate descending
                   select b;
        }
    }
}


