﻿// Entity.cs
//

using System;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Data.Services.Common;

namespace Microsoft.Azure.Linq {

    [DataServiceKey("PartitionKey", "RowKey")]
    public abstract class Entity {

        [Key]
        [ReadOnly(true)]
        [Bindable(false)]
        public virtual string PartitionKey {
            get;
            set;
        }

        [Key]
        [ReadOnly(true)]
        [Bindable(false)]
        public virtual string RowKey {
            get;
            set;
        }

        [Timestamp]
        [ReadOnly(true)]
        [Bindable(false)]
        public virtual DateTime Timestamp {
            get;
            set;
        }
    }
}
