﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Library.Services;
using System.Windows.Ria.Sync;
using Library.Web.DataModel;

namespace Library {

    public partial class MainPage : UserControl {

        private LibraryContext _context;

        private ServerSyncBehavior<LibraryContext> _serverSync;
        private LocalSyncBehavior<LibraryContext> _localSync;

        public MainPage() {
            InitializeComponent();
            _context = new LibraryContext();

            booksGrid.ItemsSource = _context.Books;
            // _context.Load(_context.GetBooksQuery());

            _localSync = new LocalSyncBehavior<LibraryContext>(TimeSpan.FromSeconds(10), "Library.json.txt");
            _context.AttachSyncBehavior(_localSync);

            _serverSync = new ServerSyncBehavior<LibraryContext>(TimeSpan.FromSeconds(30));
            _serverSync.Load(context => context.Load(context.GetBooksQuery()));
            _context.AttachSyncBehavior(_serverSync);
        }

        private void saveButton_Click(object sender, RoutedEventArgs e) {
            _context.SubmitChanges();
        }

        private void booksGrid_SelectionChanged(object sender, SelectionChangedEventArgs e) {
            bookForm.CurrentItem = booksGrid.SelectedItem;
        }
    }
}
